var Animation2D = /** @class */ (function () {
    function Animation2D(spritesheet, x, y, width, height, frames, context) {
        this.spritesheet = spritesheet;
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
        this.context = context;
        this.frames = frames;
        this.currentFrame = 0;
    }
    Animation2D.prototype.getCurrentFrame = function () {
        return this.currentFrame;
    };
    Animation2D.prototype.getFrameCount = function () {
        return this.frames;
    };
    Animation2D.prototype.getHeight = function () {
        return this.height;
    };
    Animation2D.prototype.getSpritesheet = function () {
        return this.spritesheet;
    };
    Animation2D.prototype.getWidth = function () {
        return this.width;
    };
    Animation2D.prototype.getX = function () {
        return this.x;
    };
    Animation2D.prototype.getY = function () {
        return this.y;
    };
    Animation2D.prototype.maintain = function (fps) {
        var spritesheet = this.spritesheet, x = this.x, y = this.y, width = this.width, height = this.height, context = this.context, frames = this.frames, currentFrame = this.currentFrame;
        context.drawImage(spritesheet, 0, 0, width, height, x, y, width, height);
        function u() {
            return function () {
                context.clearRect(x, y, width, height);
                context.drawImage(spritesheet, 0 + (width * currentFrame), 0, width, height, x, y, width, height);
                currentFrame++;
                if (currentFrame >= frames) {
                    currentFrame = 0;
                }
            };
        }
        setInterval(u(), (1000 / fps));
    };
    Animation2D.prototype.setCurrentFrame = function (currentFrame) {
        this.currentFrame = currentFrame;
    };
    return Animation2D;
}());
var ControlScheme = /** @class */ (function () {
    function ControlScheme(scheme) {
        this.scheme = scheme;
    }
    ControlScheme.prototype.getInputCode = function (key) {
        for (var _i = 0, _a = this.scheme; _i < _a.length; _i++) {
            var v = _a[_i];
            if (v[0] === key)
                return v[1];
        }
    };
    ControlScheme.prototype.getInputKey = function (code) {
        for (var _i = 0, _a = this.scheme; _i < _a.length; _i++) {
            var v = _a[_i];
            if (v[1] === code)
                return v[0];
        }
    };
    return ControlScheme;
}());
var Image2D = /** @class */ (function () {
    function Image2D(file) {
        var image = new Image();
        image.src = file;
        return image;
    }
    return Image2D;
}());
